onsweb.plugins.livescore = {
    defaults : {
        match_overview_class : 'o-match-overview',
        event_overview_class : 'o-event-overview',
        setup_overview_class : 'o-setup-overview',
        passport_overview_class : 'o-passport-overview',
        item_class : 'o-match-item-block',
        refresh_class : 'o-refresh-match-overview'

    },
    data : {
        current_menu_item : null,
        weeks : null,
        match_items : null,
        is_match : false,
        match_id : null,
        player_id:null,
        is_player:false,
        match:null,
        player:null,
        timestamp:0,
        linenumber:0,
        is_live:0
    },
    show_match_overview : function(){
        this._init_header();
        this._init_current_menu_item();
        this._init_url();
        this._init_match_items();
        this._create_output();
        onsweb.screen.methods.refresh_iscroll();
        },
    show_page : function(){
        this._init_header();
        this._init_current_menu_item();
        this._create_page_output();
    },
    _init_header : function(){
        onsweb.screen.data.header.item.addClass('livescore');
    },
    _init_url : function(){
        var parts = onsweb.url.get_hash();
        if(parts.length - 1 == 1){
            this.data.is_match = true;
            this.data.is_player = false;
            this.data.match_id = parts[parts.length - 1];
        }else  if(parts.length -1 > 0){
            this.data.is_player = true;
            this.data.is_match = false;
            this.data.player_id = parts[parts.length - 1];
        }else {

            this.data.is_match = false;
            this.data.is_player = false;
            this.data.match_id = null;
        }


    },
    _set_refresh_interval : function(){

	if(this.data.is_live === 1){
		var t = 10000;
		$.doTimeout('timer_id', t, function(){
			if(onsweb.url.get_hash(1) == 'match-overview' && onsweb.url.get_hash(2) == 'match-overview')
			{
				onsweb.plugins.livescore._init_match_items();
				onsweb.plugins.livescore._create_output();
				onsweb.screen.methods.refresh_iscroll();
				onsweb.menu.bind_links();
				onsweb.console.log('Refresh after 10 seconds');
			}
			return true;
		});

	}

	var t2 = 60000;
   $.doTimeout('overaltimer_id', t2, function(){
		if(onsweb.url.get_hash(1) == 'match-overview' && onsweb.url.get_hash(2) == 'match-overview')
		{
            onsweb.plugins.livescore._init_match_items();
            onsweb.plugins.livescore._create_output();
            onsweb.screen.methods.refresh_iscroll();
            onsweb.menu.bind_links();
            onsweb.console.log('Refresh after 60 seconds');
		}
        return true;
    });

    },
    _init_current_menu_item : function(){
        this.data.current_menu_item = onsweb.menu.data.current_menu_item;
    },
    _init_match_items : function(){

        if(this.data.is_match){

            this.data.match =  onsweb.ajax.call('get_match',{
                match_id:this.data.match_id,
                timestamp:onsweb.plugins.livescore.data.timestamp,
                setup:1
            });

            if(this.data.match){
                var keylist = Object.keys(this.data.match.result[this.data.match_id].events);
                if(keylist.length >0){
                    this.data.linenumber = keylist[0].replace('a','');
                }
            }
            if(this.data.match.result[this.data.match_id].match.last_edit != 0){
                onsweb.plugins.livescore.data.timestamp = this.data.match.result[this.data.match_id].match.last_edit;
            }
        }else   if(this.data.is_player){
            this.data.player =  onsweb.ajax.call('get_passport',{
                player_id:this.data.player_id
            });
        } else{
            var weeksdata = onsweb.ajax.call('get_overview',{});
            this.data.weeks = weeksdata.result.m;
            this.data.is_live = weeksdata.result.s;
        }
    },

    _create_page_output : function(){
        var content = onsweb.template.view('livescore','offline',onsweb.plugins.news.data.livescore.result);

        onsweb.page_writer.fill_content(content);
        onsweb.menu.bind_header_back_button('livescore');
        onsweb.menu.data.header.title_block.html(onsweb.plugins.news.data.livescore.result.btn);
    },
    _create_output : function(){
        if(this.data.is_match){
            this._create_match_page();
            this._create_events_overview_page_load_images();
            this._create_refresh_button();
            this._bind_live_button();
            onsweb.menu.set_header_title(gt('Wedstrijddetails'));
        }else  if(this.data.is_player){
            this._create_passport_page();
            this._load_passport_image();
            this._load_social_media_link();
            this._create_refresh_button();
            this._bind_live_button();
            onsweb.menu.set_header_title(gt('Speler details'));
        }else {
            this._create_match_overview_page();
            this._create_refresh_button();
            onsweb.menu.data.header.live_button.hide();
            onsweb.menu.bind_header_back_button('level');
            this._set_refresh_interval();
        }
    },

    _create_passport_page : function(){
        var content='';
        if(this.data.player.length > 0 || 1){

            content += onsweb.template.view('livescore','passport_info_item',this.data.player.result[this.data.player_id].info);


            content += onsweb.template.view('livescore','list_group',{
                title:  'Spelersstatistieken'
            });
            content += onsweb.template.view('livescore','statistics_title_item',{});
            if(this.data.player.result[this.data.player_id].statistics){
                $.each(this.data.player.result[this.data.player_id].statistics,function(){
                    if(this.current === 1){
                        this.current_class = 'current'
                    }else{
                        this.current_class = '';
                    }
                    content += onsweb.template.view('livescore','statistics_items',this);
                });
            }
            onsweb.page_writer.fill_content(onsweb.template.view('livescore','match_overview_list',{
                items: content,
                overview_class: onsweb.plugins.livescore.defaults.passport_overview_class
            }));
        }
    },

    _load_passport_image : function(){
        if(this.data.player.length > 0 || 1){

            if(this.data.player.result[this.data.player_id].info.photo){
                $('.passport_info_photo').css({
                    'background-image': 'url('+this.data.player.result[this.data.player_id].info.photo+')'
                });
            }
        }
    },

    _load_social_media_link : function(){
        var self = this;
        if(this.data.player.length > 0 || 1){

            if(this.data.player.result[this.data.player_id].info.twitter_url !== ''){
                $('.passport-info-item .twitter').css({
                    'display': 'block'
                });
                $('.passport-info-item .twitter').unbind('click').click(function(){
                    window.open(self.data.player.result[self.data.player_id].info.twitter_url);
                });

            }
            if(this.data.player.result[this.data.player_id].info.facebook_url !== ''){
                $('.passport-info-item .facebook').css({
                    'display': 'block'
                });
                $('.passport-info-item .facebook').unbind('click').click(function(){
                    window.open(self.data.player.result[self.data.player_id].info.facebook_url);
                });
            }

        }
    },


    _create_match_overview_page : function(){
        if(this.data.weeks.length > 0 || 1){
            var content = '',curr_group = null,match = null,self=null;
            $.each(this.data.weeks,function(){
                self = this;
                item = this;
                if(item.week_number != curr_group){
                    content += onsweb.template.view('livescore','list_group',{
                        title:  'Week ' + item.week_number
                    });
                    curr_group = item.week_number;
                }

                $.each(self.matches,function(){
                    match = this.match;
                    match.bind_class = onsweb.menu.defaults.add_class;
                    onsweb.plugins.livescore.status(match);
                    content += onsweb.template.view('livescore','match_overview_list_item', match);

                });
            });
            onsweb.page_writer.fill_content(onsweb.template.view('livescore','match_overview_list',{
                items: content,
                overview_class: onsweb.plugins.livescore.defaults.match_overview_class
            }));
            onsweb.menu.bind_header_back_button('livescore');
        } else {
            onsweb.page_writer.fill_content(gt('Geen wedstrijden gevonden. Controleer je internet verbinding en probeer het later nog een keer.'));
        }
    },


    _create_match_overview_page_load_images: function(){
        var item = null,id=null;
        $.each($('.'+onsweb.plugins.livescore.match_overview_class_class+' ul li.match-item'),function(){
            item = $(this);
            id = 'i-'+item.attr('rel');
            if(onsweb.plugins.news.data.news_items[id] && onsweb.plugins.news.data.news_items[id].p != ''){
                item.find('.picture').css({
                    'background-image': 'url('+onsweb.plugins.news.data.news_items[id].p+')'
                });
            }

        });
    },

    _create_match_page : function(){
        var match=null;
        match = this.data.match.result[this.data.match_id];
        var view1 = onsweb.plugins.livescore._create_setup(match);
        var view2 = onsweb.plugins.livescore._create_events(match);
        onsweb.page_writer.fill_content(view1 + view2);

        $('.'+onsweb.plugins.livescore.defaults.setup_overview_class).hide();
    },


    _create_details :function(match){
        var content='';
        content =  onsweb.template.view('livescore','detail_bar',{});
        match.match.bind_class ='';
        onsweb.plugins.livescore.status(match.match);
        content += onsweb.template.view('livescore','match_overview_list_item', match.match);
        return content;
    },

    _create_setup : function(match){
        var content='', overview_class;
        var details = onsweb.plugins.livescore._create_details(match);
        match.match.bind_class ='';
        if(match.setup){
            var title=null,attack=true;
            var awayTeam =match.setup.teams.away_team.team_name;
            var homeTeam = match.setup.teams.home_team.team_name;

            if(match.setup.teams.home_team.players){
                $.each(match.setup.teams.home_team.players,function(){
                    item = this;

                    if(attack){
                        title = 'Aanval '
                    }else{
                        title = 'Verdediging '
                    };
                    content +=  onsweb.template.view('livescore','list_group',{
                        title:  title + homeTeam

                    });
                    $.each(item,function(){
                        this.bind_class = onsweb.menu.defaults.add_class;
                        content +=  onsweb.template.view('livescore','setup_list_item',this);
                        if(this.substitutions.length >0){
                            $.each(this.substitutions,function(){
                                content +=  onsweb.template.view('livescore','setup_sub_list_item',this);
                            });
                        }
                    });
                    attack=false;
                });

            }

            if(match.setup.teams.away_team.players){
                $.each(match.setup.teams.away_team.players,function(){
                    var item = this;

                    if(attack){
                        title = 'Aanval '
                    }else{
                        title = 'Verdediging '
                    };
                    content +=  onsweb.template.view('livescore','list_group',{
                        title:  title + awayTeam

                    });
                    $.each(item,function(){
                        this.bind_class = onsweb.menu.defaults.add_class;
                         if(this.player_id !== 0){
                        content +=  onsweb.template.view('livescore','setup_list_item',this);
                         }else{
                             this.bind_class="norel";
                               content +=  onsweb.template.view('livescore','setup_unknown_list_item',this);
                         }
                        if(this.substitutions.length >0){
                            $.each(this.substitutions,function(){
                                if(this.player_id !== 0){
                                content +=  onsweb.template.view('livescore','setup_sub_list_item',this);

                            }else{
                                this.bind_class="norel";
                                content +=  onsweb.template.view('livescore','setup_sub_unknown_list_item',this);
                            }
                              });
                        }
                    });


                    attack=false
                });

            }

            if(match.officials){
                content +=  onsweb.template.view('livescore','list_group',{
                    title:  'Officials'
                });

                if(!match.officials.referee) {
                    match.officials.referee='';
                }
                content +=  onsweb.template.view('livescore','setup_officials_list_item',{
                    title:'Scheidsrechter',
                    name: match.officials.referee
                });
                if(!match.officials.assistent) {
                    match.officials.assistent='';
                }
                content +=  onsweb.template.view('livescore','setup_officials_list_item',{
                    title:'Assistent',
                    name: match.officials.assistent
                });
                if(!match.officials.jury) {
                    match.officials.jury='';
                }
                content +=  onsweb.template.view('livescore','setup_officials_list_item',{
                    title:'Juryvoorzitter',
                    name: match.officials.jury
                });

            }

            return onsweb.template.view('livescore','setup_list',{
                items: details+content,
                overview_class: onsweb.plugins.livescore.defaults.setup_overview_class
            });

        }

    },


    _create_events : function(match){
        var content='', overview_class;
        var details = onsweb.plugins.livescore._create_details(match);
        if(match.topscorers && match.topscorers.length >0){

            content +=  onsweb.template.view('livescore','list_group',{
                title: "Topscorers"
            });
            $.each(match.topscorers,function(){
                if(this.player_id !== 0){
                this.bind_class = onsweb.menu.defaults.add_class;
                content +=  onsweb.template.view('livescore','topscorer_list_item',this);
            } else {
                  this.bind_class = "norel";
                content +=  onsweb.template.view('livescore','topscorer_unknown_list_item',this);
            }
        });
        }

        content +=  onsweb.template.view('livescore','list_group',{
            title: "Scoreverloop"
        });

        if(match.events){
            var keylist = Object.keys(match.events);
            if(keylist.length >0 ){
                var i = 0;
                $.each(match.events,function(){


                    this.display_event = this.time +'\' ' +this.event;
                    if(!this.player_name){
                        this.player_name ='';
                    }
                    switch(this.event){

                        case 'Startwedstrijd':case 'Einde1ehelft':case'Start2ehelft':case'Einde2ehelft':case'Start1eVerlenging':case'Einde1eVerlenging':case'Start2eVerlenging':case'Einde2eVerlenging':case'StartGoldenGoal':case 'EindeGoldenGoal':case
                            'StartStrafworpen':case 'EindeStrafworpen':case'EindeLiveScore':case 'Timeout':
                            content +=  onsweb.template.view('livescore','event_norel_list_item',{
                                event:this,
                                event_class:this.event,
                                bind_class: "norel"
                            });
                            break;
                        case 'Wisselin':case'Wisseluit':case 'Gelekaart':case'Rodekaart':

                             if(this.player_id !==0 ){
                            content +=  onsweb.template.view('livescore','event_noscore_list_item',{
                                event:this,
                                event_class:this.event,
                                bind_class: onsweb.menu.defaults.add_class,
                                id:keylist[i]
                            });
                             }else{
                                    content +=  onsweb.template.view('livescore','event_noscore_unknown_list_item',{
                                event:this,
                                event_class:this.event,
                                bind_class: "norel",
                                id:keylist[i]
                            });
                             }
                            break

                        default:

                            if(this.player_id !==0 ){
                            content +=  onsweb.template.view('livescore','event_score_list_item',{
                                event:this,
                                event_class:this.event,
                                bind_class: onsweb.menu.defaults.add_class,
                                id:keylist[i]

                            });
                            }else{
                                content +=  onsweb.template.view('livescore','event_score_unknown_list_item',{
                                event:this,
                                event_class:this.event,
                                bind_class: "norel",
                                id:keylist[i]
                            });
                            }
                            break;
                    }
                    i++

                });


            }else{
                content +=  onsweb.template.view('livescore','event_no_data_list_item',{
                    bind_class: "norel"
                });
            }
        }

        return onsweb.template.view('livescore','event_list',{
            items: details+content,
            overview_class: onsweb.plugins.livescore.defaults.event_overview_class
        });

    },


    _create_events_overview_page_load_images: function(){
        $('.'+onsweb.plugins.livescore.defaults.event_overview_class + ' ul').each(function(i, items_list){


            $(items_list).find('li.event-item').each(function(j, li){
                item = $(this);
                if(item.attr('id')){
                    id = item.attr('id');
                    if(onsweb.plugins.livescore.data.match.result[onsweb.plugins.livescore.data.match_id].events[id] && onsweb.plugins.livescore.data.match.result[onsweb.plugins.livescore.data.match_id].events[id].club_logo != ''){
                        item.find('.logo').css({
                            'background': 'url('+onsweb.plugins.livescore.data.match.result[onsweb.plugins.livescore.data.match_id].events[id].club_logo+') no-repeat center'
                        });
                    }

                }
            });

        });


        $('.topscorer').each(function(i, item){
            item = $(this);
            item.find('.logo').css({
                'background': 'url("'+onsweb.plugins.livescore.data.match.result[onsweb.plugins.livescore.data.match_id].topscorers[i].club_logo+'") no-repeat center'
            });

        });
    },



    _bind_live_button : function(){
        onsweb.menu.data.header.live_button.show();
        $('.'+onsweb.menu.defaults.header_live_button_class).unbind('click').click(function(){
            onsweb.loader.start('onsweb::plugins::livescore::matchoverview');
            onsweb.url.change_hash('match-overview');


        });
    },
    _create_refresh_button : function(){
        onsweb.menu.set_header_right_menu(onsweb.template.view('livescore', 'top_right_menu',{
            class_name : this.defaults.refresh_class
        }));
        $('.'+this.defaults.refresh_class).unbind('click').click(function(){

            onsweb.plugins.livescore.refresh_screen();



        });
    },



    refresh_screen : function(){
        this._refresh_data();
        this._create_output();
        onsweb.menu.bind_links();
        onsweb.menu.bind_header_back_button()
    },


    _refresh_data : function(){
        if(this.data.is_match){
            var oldmatchdata = new Object();
            oldmatchdata.events = this.data.match.result[this.data.match_id].events;


            onsweb.loader.start('onsweb::plugins::livescore::refresh');
            this.data.match =  onsweb.ajax.call('get_match',{
                match_id:this.data.match_id,
                timestamp:this.data.timestamp,
                setup:1,
                identifier: this.data.linenumber
            });

            if(this.data.match.result[this.data.match_id].match.last_edit != 0){
                this.data.timestamp = this.data.match.result[this.data.match_id].match.last_edit;
            }
            if(this.data.match.result[this.data.match_id].clear === 0){
                if(this.data.match){
                    $.extend(true,this.data.match.result[this.data.match_id],oldmatchdata);
                    var keylist = Object.keys(this.data.match.result[this.data.match_id].events);
                    if(keylist.length > 0){
                        this.data.linenumber = keylist[0].replace('a','');
                    }
                }
            }else{
                this.data.linenumber = 0;
            }

        }else  if(this.data.is_player){
            onsweb.loader.start('onsweb::plugins::livescore::refresh');
            this.data.player =  onsweb.ajax.call('get_passport',{
                player_id:this.data.player_id
            });
        }else {
            onsweb.loader.start('onsweb::plugins::livescore::refresh');
            this.data.weeks =  onsweb.ajax.call('get_overview',{});
        }

    },


    status : function(match){
        var status = '';
        switch(match.status){
            case '0': case 0:
                status = 'AANVANG';
                break;
            case '1': case 1:
                status = 'LIVE';
                break;
            case '2': case 2:
                status = 'EINDE';
                break;
            default:
                status = 'AANVANG';
                break;
        }
        match.statustext = status;
        match.lcstatus = status.toLowerCase();

    }
}