onsweb.plugins.my_nhv = {
	defaults : {
		top_menu_class : 'o-top-menu',
		top_menu_item_class : 'o-top-menu-item',
		profile_class : 'profile',
		favorite_class : 'favorite',
		newsletter_class : 'newsletter',
		adjust_button_class : 'o-profile-adjust-button',
		save_button_class : 'o-profile-save-button',
		error_class : 'error',
		favorite_list_item_class : 'o-favorite-list-item',
		favorite_list_class : 'o-favorite-list',
		favorite_delete_class : 'o-favorite-delete'
	},
	data : {
		current_item : null,
		top_menu : null,
		content : '',
		user : null,
		adjust : false,
		bind_save_button : false,
		favorites : null
	},
	show_profile : function(){
		this._init('profile');

		this.data.adjust = onsweb.url.get_hash(3) == 'adjust' ? true : false;
		this._create_profile_page();
		onsweb.page_writer.fill_content(this.data.top_menu + this.data.content);

		this._bind();
	},
	show_favorite: function(){
		this._init('favorite');
		this._create_favorites_page(false);
		onsweb.page_writer.fill_content(this.data.top_menu + this.data.content);
		this._bind();
	},
	show_favorite_adjust: function(){
		this._init('favorite-adjust');
		this._create_favorites_page(true);
		onsweb.page_writer.fill_content(this.data.top_menu + this.data.content);
		this._bind();
	},
	show_newsletter: function(){
		this._init('newsletter');
		onsweb.page_writer.fill_content(this.data.top_menu + this.data.content);
	},
	_init : function(name){
		this.data.current_item = name;
		this._add_logout_button();
		this._create_top_menu();
		this.data.content = '';
	},
	_bind : function(){
		/* Bind stuff */
		switch(this.data.current_item){
			case 'profile':
				if(this.data.bind_save_button){
					this.data.bind_save_button = false;
					this._bind_save_button();
				}
				break;
			case 'favorite-adjust':
				this._bind_delete_button();
				onsweb.menu.bind_links();
				break;
			case 'favorite':
				this._bind_adjust_button();
				onsweb.menu.bind_links();
				break;

		}

	},
	_create_top_menu : function(){
		var d = this.defaults;
		d.profile_active = this.data.current_item == 'profile' ? 'active' : '';
		d.favorite_active = this.data.current_item == 'favorite' || this.data.current_item == 'favorite-adjust' ? 'active' : '';
		d.newsletter_active = this.data.current_item == 'newsletter' ? 'active' : '';
		d.adjust_add_class = onsweb.menu.defaults.change_class;
		this.data.top_menu = onsweb.template.view('my_nhv','top_menu', d);
	},
	_add_logout_button : function(){
		onsweb.plugins.auth.add_logout_top_button();
	},
	_create_profile_page : function(){
		var user = onsweb.plugins.auth.get_user_info();
		if(user != null){
			this.data.user = user;
			user.adjust_button_class = this.defaults.adjust_button_class;
			user.adjust_add_class = onsweb.menu.defaults.change_class;

			if(this.data.adjust){
				user.error_class = this.defaults.error_class;
				user.save_button_class = this.defaults.save_button_class;
				this.data.content = onsweb.template.view('my_nhv','adjust_profile', user);
				this.data.bind_save_button = true;
			} else {
				this.data.content = onsweb.template.view('my_nhv','profile_view',user);
			}
		}
	},
	_bind_save_button : function(){
		$('.'+this.defaults.save_button_class).unbind('click').click(function(){
			var data = {
				f : $('.firstname_input').val(),
				i : $('.insertion_input').val(),
				l : $('.lastname_input').val(),
				c : $('.code_input').val()
			};
			var r = onsweb.plugins.auth.save_user_info(data);
			if(r.error == undefined || r.error == true){
				/* Show error */
				onsweb.plugins.my_nhv._show_error(r.error_message);
			} else {
				/* Redirect */
				onsweb.url.change_hash('mijn-nhv/profile');
			}
		});
	},
	_show_error : function(m){
		$('.'+this.defaults.error_class).html(m);
	},
	_clear_error : function(){
		$('.'+this.defaults.error_class).html('');
	},
	_create_favorites_page : function(adjust){
		this.data.favorites = onsweb.plugins.auth.get_user_favorites();
		if(this.data.favorites != null ){
			this._create_favorites_list(adjust);
		} else {
			this.data.content = gt('Geen favoriten gevonden');
		}
	},
	_create_favorites_top_menu : function(){
		this.data.content = onsweb.template.view('my_nhv','favorite_top_menu',{});
	},
	_create_favorites_list : function(adjust){
		/* Incase it isnt set, set it false */
		adjust = adjust == true ? true : false;
		var item,list='',type=null;
		$.each(this.data.favorites, function(){
			item = this;
			if(item.id != undefined){
				if(item.t != type){
					type = item.t;
					var title = '';
					switch(item.t){
						default:
							title = item.t;
							break;
						case 'club':
							title = 'Clubs';
							break;
						case 'team':
							title = 'Teams';
							break;

					}
					list += onsweb.template.view('my_nhv','favorite_list_group_title',{
						t: title
					});
				}
				item.favorite_delete_class = onsweb.plugins.my_nhv.defaults.favorite_delete_class;
				item.favorite_list_item_class = onsweb.plugins.my_nhv.defaults.favorite_list_item_class;
				switch(type){
					case 'team':
						item.url = 'competitie/'+item.c+'/teams/'+item.id;
						break;
					default:
					case 'club':
						item.url = 'competitie/'+item.id+'/program';
						break;
				}

				item.change_class = onsweb.menu.defaults.change_class;
				if(adjust){
					list += onsweb.template.view('my_nhv', 'favorite_list_item_adjust',item);
				} else {
					list += onsweb.template.view('my_nhv', 'favorite_list_item',item);
				}
			}
		});
		this.data.content = onsweb.template.view('my_nhv','favorite_list',{
			items: list,
			favorite_list_class : this.defaults.favorite_list_class,
			adjust_button_class : this.defaults.adjust_button_class,
			button_title : adjust ? gt('Klaar') : gt('Aanpassen')
		});
	},
	_bind_delete_button : function(){
		$('.'+this.defaults.favorite_delete_class).unbind('click').click(function(){
			var item = $(this);
			var r = onsweb.plugins.auth.delete_user_favorite({
				favorite_id: item.attr('rel')
			});
			if(r.result){
				item.remove();
			}
		});
		$('.'+this.defaults.adjust_button_class).unbind('click').click(function(){
			onsweb.plugins.my_nhv.show_favorite();
		});
	},
	_bind_adjust_button : function(){
		$('.'+this.defaults.adjust_button_class).unbind('click').click(function(){
			onsweb.plugins.my_nhv.show_favorite_adjust();
		});
	}
};