/* Add plugin specific url to the ajax controller */
onsweb.ajax.defaults.url.get_clubs = 'competition/get_clubs/';
onsweb.ajax.defaults.url.get_program = 'competition/get_program/';
onsweb.ajax.defaults.url.get_results = 'competition/get_results/';
onsweb.ajax.defaults.url.get_standings = 'competition/get_standings/';
onsweb.ajax.defaults.url.get_teams = 'competition/get_club_teams/';
onsweb.ajax.defaults.url.get_club = 'competition/get_club/';
onsweb.ajax.defaults.url.get_app_favorites = 'competition/get_app_favorites/';

onsweb.plugins.competition = {
	data : {
		menu_active: 'program',
		menu_active_class : 'active',
		clubs : {},
		clubs_result : '',
		teams : {},
		team : '',
		club : {
			teams : null
		},
		matches : {},
		program : {
			team : null,
			club : null
		},
		results : {
			team : null,
			club : null
		},
		standings : {
			team : null
		},
		search_text : '',
		favorites : null
	},
	show_page : function(){
		var content = '',
			club_id = onsweb.url.get_hash(2),
			item	= onsweb.url.get_hash(3),
			match_id = team_id = onsweb.url.get_hash(4);

		if(club_id != 'competitie')
		{

			switch(item)
			{
				case 'results':
					this.data.menu_active = 'results';
					this._add_favorite_button(club_id);
					content = onsweb.plugins.competition.show_results(club_id, '', match_id);
					break;
				case 'teams':
					this.data.menu_active = 'teams';
					this._add_favorite_button(club_id, team_id);
					content = onsweb.plugins.competition.show_teams(club_id);
					break;
				case 'club':
					this.data.menu_active = 'club';
					this._add_favorite_button(club_id);
					content = onsweb.plugins.competition.show_club(club_id);
					break;
				default:
				case 'program':
					this.data.menu_active = 'program';
					this._add_favorite_button(club_id);
					content = onsweb.plugins.competition.show_program(club_id, '', match_id);
					break;
			}
		}
		else
		{
			this._get_favorites(true);
			content = this.show_clubs();
		}
		onsweb.page_writer.fill_content(content);
	},
	show_clubs : function(){
		var d = {},
			search_text = this.data.search_text != '' ? this.data.search_text : gt('Zoek club'),
			s = search_text != gt('Zoek club') ? search_text : '';

		d.results = this._search_clubs(s);

		d.search_text = search_text != gt('Zoek club') ? search_text : gt('Zoek club');
		return onsweb.views.competition.show_club_search(d);
	},
	show_program : function(club_id, team_id, match_id){

		/* Show selected match */
		if(match_id != '' && match_id != undefined && match_id > 0)
		{
			return this.show_match(match_id);
		}

		var content = team_id != '' && team_id != undefined ? this._show_team_menu(club_id, team_id) : this._show_club_menu(club_id),
			blocks = '',
			results = this._get_results(club_id, team_id, 'program'),
			result = false,
			d = this._get_club(club_id);

		/* Set title to club and make sure no team is selected */
		if(!(team_id != '' && team_id != undefined))
		{
			onsweb.menu.set_header_title(d.competition_club_name);
		}

		$.each(results, function(date, matches)
		{
			block = {date: date, rows: ''};
			$.each(matches.items, function(i, match){
				match.cls = (onsweb.plugins.competition._substr_count(team_id, match.home_team_id)>0 || onsweb.plugins.competition._substr_count(team_id, match.away_team_id)>0) ? 'team' : 'poule';
				block.rows += onsweb.views.competition.show_match_program(match);
				result = true;
				onsweb.plugins.competition.data.matches[match.competition_program_id] = match;
			});
			blocks += onsweb.views.competition.show_match_block(block);
		});

		if(result == false)
		{
			return content + onsweb.views.competition.show_no_results();
		}

		/* Bind match items */
		this._bind_matches();

		/* Set poule/team switch */
		content += team_id != '' && team_id != undefined ? this._show_poule_team_switch() : '';
		this._bind_switch_menu();

		content += onsweb.views.competition.show_program(blocks);

		return content;
	},
	show_results : function(club_id, team_id, match_id){

		/* Show selected match */
		if(match_id != '' && match_id != undefined && match_id > 0)
		{
			return this.show_match(match_id);
		}

		var content = team_id != '' && team_id != undefined ? this._show_team_menu(club_id, team_id) : this._show_club_menu(club_id),
			blocks = '',
			results = this._get_results(club_id, team_id, 'results'),
			result = false,
			d = this._get_club(club_id);

		/* Set title to club and make sure no team is selected */
		if(!(team_id != '' && team_id != undefined))
		{
			onsweb.menu.set_header_title(d.competition_club_name);
		}

		$.each(results, function(date, matches)
		{
			block = {date: date, rows: ''};
			$.each(matches.items, function(i, match){
				match.cls = (onsweb.plugins.competition._substr_count(team_id, match.home_team_id)>0 || onsweb.plugins.competition._substr_count(team_id, match.away_team_id)>0) ? 'team' : 'poule';
				block.rows += onsweb.views.competition.show_match_result(match);
				result = true;
				onsweb.plugins.competition.data.matches[match.competition_program_id] = match;
			});
			blocks += onsweb.views.competition.show_match_block(block);
		});

		if(result == false)
		{
			return content + onsweb.views.competition.show_no_results();
		}

		/* Bind match items */
		this._bind_matches();

		/* Set poule/team switch */
		content += team_id != '' && team_id != undefined ? this._show_poule_team_switch() : '';
		this._bind_switch_menu();

		content += onsweb.views.competition.show_program(blocks);

		return content;
	},
	show_standing : function(club_id, team_id){
		var content = team_id != '' && team_id != undefined ? this._show_team_menu(club_id, team_id) : this._show_club_menu(club_id),
			results = this._get_standings(team_id, 'standings'),
			blocks = '',
			block = '',
			lastline = '',
			result = false,
			d = this._get_club(club_id);

		/* Set title to club and make sure no team is selected */
		if(!(team_id != '' && team_id != undefined))
		{
			onsweb.menu.set_header_title(d.competition_club_name);
		}

		$.each(results, function(i, poule)
		{
			block = {poule_name: poule.poule.competition_poule_name, rows: ''};
			$.each(poule.lines, function(i, line){
				line.cls = club_id == line.club_id ? 'team' : '';
				block.rows += onsweb.views.competition.show_standing_line(line);
				result = true;
				lastline = line;
			});
			block.poule_name += ' ' + gt(lastline.sport);
			blocks += onsweb.views.competition.show_standing_block(block);
		});

		if(result == false)
		{
			return content + onsweb.views.competition.show_no_results();
		}

		content += onsweb.views.competition.show_standings(blocks);

		return content;
	},
	show_teams : function(club_id){
		var team_id	= onsweb.url.get_hash(4),
			item	= onsweb.url.get_hash(5),
			match_id = onsweb.url.get_hash(6),
			content = '',
			blocks = '',
			d = this._get_club(club_id);

		if(team_id != undefined)
		{
			if(this.data.teams[team_id] != undefined)
			{
				this.data.team = this.data.teams[team_id];
				onsweb.menu.set_header_title(this.data.team.team_name);
			}

			switch(item){
				case 'results':
					this.data.menu_active = 'results';
					content += this.show_results(club_id, team_id, match_id);
					break;
				case 'standing':
					this.data.menu_active = 'standing';
					content += this.show_standing(club_id, team_id);
					break;
				case '':
				case 'program':
				default:
					this.data.menu_active = 'program';
					content += this.show_program(club_id, team_id, match_id);
					break;
			}
			onsweb.menu.bind_header_back_button('go_hash','competitie/'+club_id+'/teams');
		}
		else
		{
			/* Set title to club */
			onsweb.menu.set_header_title(d.competition_club_name);

			/* Reset active team */
			this.data.team = '';

			var d = {items:'', block_class:'teams'},
				content = this._show_club_menu(club_id),
				result = this._get_teams(club_id),
				blocks = '';
					//{'1':{name:'test1',rel:1},'2':{name:'test2',rel:2}};

			$.each(result, function(age, teams)
			{
				var block = {name: age, items: ''};
				$.each(teams, function(i, team){
					team.letter = age;
					block.items += onsweb.views.competition.show_team_list_item(team);

					onsweb.plugins.competition.data.teams[team.team_id_group] = team;
				});

				blocks += onsweb.views.competition.show_list_block(block);
			});
			d.items = blocks;
			content += onsweb.views.competition.show_list(d);

			//Bind team links
			this._bind_teams(club_id);
		}
		//onsweb.menu.bind_header_back_button('go_hash','');
		return content;
	},
	show_club : function(club_id){
		var content = this._show_club_menu(club_id),
			d = this._get_club(club_id);

		/* Set title to club */
		onsweb.menu.set_header_title(d.competition_club_name);

		content += onsweb.views.competition.show_club_info(d);

		this._bind_club_info();

		return content;
	},
	show_match : function(match_id){
		var match = {};
		if(this.data.matches[match_id] != undefined)
		{
			match = this.data.matches[match_id];
		}
		else
		{
			match = onsweb.ajax.call('get_match', {match_id: match_id});
		}

		match.result = '';
		if(match.home_score > 0 || match.away_score > 0)
		{
			match.result = onsweb.views.competition.show_match_result_line(match);
			match.time = match.time != null && match.time != ''  ? match.time : gt('niet bekend');
		}

		match.sport_name = gt(match.sport);
		match.time = match.time != null && match.time != ''  ? match.time : gt('(nog) niet bekend');
		match.match_officials = match.match_officials != null && match.match_officials != '' ? match.match_officials : gt('(nog) niet bekend');
		match.field = match.field != null && match.field != ''  ? match.field : gt('(nog) niet bekend');
		match.field_type = match.field_type != null && match.field_type != ''  ? match.field_type : '-';

		return onsweb.views.competition.show_match(match);
	},
	_get_results : function(club_id, team_id, type){
		var results = {};
		if(team_id != '' && team_id != undefined)
		{
			if(this.data[type].team != null && this.data[type].team[team_id] != undefined)
			{
				results = this.data[type].team[team_id];
			}
			else
			{
				results = onsweb.ajax.call('get_'+type, {club_id:club_id, team_id:team_id});
				this.data[type].team = {};
				this.data[type].team[team_id] = results;
			}

		}
		else
		{
			if(this.data[type].club != null && this.data[type].club[club_id] != undefined)
			{
				results = this.data[type].club[club_id];
			}
			else
			{
				results = onsweb.ajax.call('get_'+type, {club_id:club_id});
				this.data[type].club = {};
				this.data[type].club[club_id] = results;
			}
		}
		return results;
	},
	_get_standings : function(team_id, type){
		var results = {};
		if(team_id != '' && team_id != undefined)
		{
			if(this.data[type].team != null && this.data[type].team[team_id] != undefined)
			{
				results = this.data[type].team[team_id];
			}
			else
			{
				results = onsweb.ajax.call('get_standings', {team_id:team_id});
				this.data[type].team = {};
				this.data[type].team[team_id] = results;
			}

		}
		return results;
	},
	_get_teams : function(club_id){
		var results = {};
		if(this.data.club.teams != null && this.data.club.teams[club_id] != undefined)
		{
			results = this.data.club.teams[club_id];
		}
		else
		{
			results = onsweb.ajax.call('get_teams',{club_id:club_id});
			this.data.club.teams = {};
			this.data.club.teams[club_id] = results;
		}
		return results;
	},
	_get_club : function(club_id){
		var d = {};
		if(this.data.clubs[club_id] != undefined)
			d = this.data.clubs[club_id];
		else
			d = this.data.clubs[club_id] = onsweb.ajax.call('get_club', {club_id: club_id})
		return d;
	},
	_show_club_menu : function(club_id){
		var d = {club_id: club_id};
		d[this.data.menu_active] = this.data.menu_active_class;
		d.change_class = onsweb.menu.defaults.change_class;
		d.rel = onsweb.url.get_hash(1)+'/'+club_id+'/';
		//this._bind_club_menu(club_id);
		return onsweb.template.view('competition','show_club_menu',d);
	},
	_search_clubs : function(search_text){
		var content = '',
			d = {items:'', block_class:'club'},
			result = onsweb.data.get('get_clubs'),
			blocks = '',
			rg = new RegExp(search_text,'i'),
			total = 0,
			club_name = '',
			city_name = '';

		if(result == undefined)
		{
			result = onsweb.ajax.call('get_clubs');
			onsweb.data.set('get_clubs', result);
		}
		$.each(result, function(letter, clubs)
		{
			var block = {name: letter, items: ''},
				i = 0;
			$.each(clubs, function(j, club){

				club_name = club.competition_club_name;
				city_name = club.competition_facility_city;

				if(search_text == '' || (search_text != '' && (club_name.search(rg) != -1 || city_name.search(rg) != -1)))
				{
					club.letter = letter;
					block.items += onsweb.views.competition.show_club_list_item(club);

					if(onsweb.plugins.competition.data.clubs[club.competition_club_id] == undefined)
					{
						onsweb.plugins.competition.data.clubs[club.competition_club_id] = {};
					}
					onsweb.plugins.competition.data.clubs[club.competition_club_id].competition_club_name = club.competition_club_name;
					onsweb.plugins.competition.data.clubs[club.competition_club_id].competition_facility_address = club.competition_facility_address;
					onsweb.plugins.competition.data.clubs[club.competition_club_id].competition_facility_postcode = club.competition_facility_postcode;
					onsweb.plugins.competition.data.clubs[club.competition_club_id].competition_facility_city = club.competition_facility_city;
					onsweb.plugins.competition.data.clubs[club.competition_club_id].competition_club_website = club.competition_club_website;

					i++;
				}
			});

			if(i>0)
			{
				blocks += onsweb.views.competition.show_list_block(block);
			}
			total += i;
		});
		d.items = blocks;
		content = onsweb.views.competition.show_club_list(d);

		//Bind functionality
		this._bind_club_items();

		return content;
	},
	_bind_club_items : function(){
		$('ul.club li.club').die().live('click', function()
		{
			onsweb.url.add_hash($(this).attr('rel'));
		});
		$('#search_reset').die().live('click', function(){
			$('#search_club').val('').trigger('keyup');
		})
		$('#search_club').die().live('keyup', function(){
			var search_text = onsweb.plugins.competition._addslashes($(this).val());
			onsweb.plugins.competition.data.search_text = search_text;

			var content = onsweb.plugins.competition._search_clubs(search_text);
			$('#search_clubs').empty().html(content);
		}).live('focus', function(){
			$('#search_reset').show();
		}).live('blur', function(){
			$('#search_reset').hide();
		});

	},
	_bind_club_menu : function(club_id){
		$('ul.club_menu li').die().live('click', function()
		{
			onsweb.url.change_hash(onsweb.url.get_hash(1)+'/'+club_id+'/'+$(this).attr('rel'));
		});
	},
	_show_team_menu : function(club_id, team_id){
		var d = {club_id: club_id, team_id: team_id};
		d[this.data.menu_active] = this.data.menu_active_class;
		d.rel = onsweb.url.get_hash(1)+'/'+club_id+'/teams/'+team_id+'/';
		d.change_class = onsweb.menu.defaults.change_class;
		//this._bind_team_menu(club_id, team_id);
		return onsweb.template.view('competition','show_team_menu',d);
	},
	_bind_matches : function(){
		$('.matches li.match').die().live('click', function(){
			var match_id = $(this).attr('rel');
			onsweb.url.add_hash(match_id);
		});
	},
	_bind_team_items : function(){
		$('ul.team li').die().live('click', function()
		{
			onsweb.url.add_hash($(this).attr('rel'));
		});
	},
	_bind_team_menu : function(club_id, team_id){
		$('ul.team_menu li').die().live('click', function()
		{
			onsweb.url.change_hash(onsweb.url.get_hash(1)+'/'+club_id+'/teams/'+team_id+'/'+$(this).attr('rel'));
		});
	},
	_bind_teams : function(club_id){
		$('ul.teams li.club').die().live('click', function()
		{
			onsweb.url.change_hash(onsweb.url.get_hash(1)+'/'+club_id+'/'+onsweb.url.get_hash(3)+'/'+$(this).attr('rel'));
		});
	},
	_bind_club_info : function(){

	},
	_addslashes : function(str)
	{
		str=str.replace(/\\/g,'\\\\');
		str=str.replace(/\'/g,'\\\'');
		str=str.replace(/\"/g,'\\"');
		str=str.replace(/\0/g,'\\0');
		return str;
	},
	_bind_switch_menu : function(){
		$('.o-switch li').die().live('click', function(){
			var rel = $(this).attr('rel');
			$('li.poule').hide();
			$('li.'+rel).show();
			$('.o-switch li').removeClass('active');
			$(this).addClass('active');
		});
	},
	_show_poule_team_switch : function(){
		return onsweb.views.competition.show_poule_team_switch();
	},
	_add_favorite_button : function(club_id, team_id){
		var favorite = this._check_favorite(club_id, team_id);
		var	favorite_class = favorite.id == club_id || (team_id != undefined && favorite.id == team_id) ? 'delete_favorite' : 'add_favorite';

		favorite_class = onsweb.plugins.auth.is_logged_in() ? favorite_class : 'login_favorite';

		var btn = onsweb.views.competition.show_favorite_button(club_id, favorite_class);
		onsweb.menu.set_header_right_menu(btn);

		var type = team_id != undefined ? 'team' : 'club';
		var id = team_id != undefined ? team_id : club_id;

		$('.add_favorite').die().live('click', function(){
			var result = onsweb.plugins.auth.add_user_favorite({club_id: id, type:type});
			onsweb.plugins.competition._set_favorites(result.favorites);
			onsweb.plugins.competition._add_favorite_button(club_id, team_id);
			return false;
		});
		$('.delete_favorite').die().live('click', function(){
			var result = onsweb.plugins.auth.delete_user_favorite({favorite_id: favorite.f_id});
			onsweb.plugins.competition._set_favorites(result.favorites);
			onsweb.plugins.competition._add_favorite_button(club_id, team_id);
			return false;
		});
		$('.login_favorite').die().live('click', function(){
			onsweb.alert.showMessage(gt('U dient eerst in te loggen op Mijn nhv voordat u fav. kunt maken.'));
		});
	},
	_get_favorites : function(force){
		//onsweb.console.log(this.data.favorites);
		if(this.data.favorites != null && onsweb.plugins.auth.is_logged_in() || force == true){
			this._set_favorites(onsweb.plugins.auth.get_user_favorites());
		}
	},
	_set_favorites : function(f){
		this.data.favorites = f;
	},
	_check_favorite : function(club_id, team_id){
		var fav = false;
		if(this.data.favorites != null)
		{
			onsweb.console.log('favorites:do loop');
			$.each(this.data.favorites, function(i, favorite){
				if(team_id != undefined)
				{
					if(team_id == favorite.id)
					{
						fav = favorite;
					}
				}
				else if(club_id == favorite.id)
				{
					fav = favorite;
				}
			});
		}
		return fav;
	},
	_substr_count : function(haystack, needle, offset, length) {
		var pos = 0,
			cnt = 0;
		haystack += '';
		needle += '';
		if (isNaN(offset)) {
			offset = 0;}
		if (isNaN(length)) {
			length = 0;
		}
		offset--;
		while ((offset = haystack.indexOf(needle, offset + 1)) != -1) {
			if (length > 0 && (offset + needle.length) > length) {
				return false;
			} else {cnt++;
			}
		}

		return cnt;
	}
};
