onsweb.plugins = {};
onsweb.plugins.page_text = {
    data : {
        current_menu_item : null,
        pages : null
    },
    show_page : function(menu_item){
        this._init_current_menu_item(menu_item);
        this._fill_pages();
        this._write_page();
    },
    show_page_with_submenu: function(menu_item){
        this._init_current_menu_item(menu_item);
        this._fill_pages();
        this._write_page_with_submenu();
    },
    _fill_pages : function(){
        if(this.data.pages == null){
            this.data.pages = onsweb.data.get('pages');
        }
    },
    _write_page : function(){
        var content = '';
        if(this.data.pages[this.data.current_menu_item.page_id]){
            content = onsweb.template.view('page_text', 'page', this.data.pages[this.data.current_menu_item.page_id]);
        }
        onsweb.page_writer.fill_content(content);
    },
    _write_page_with_submenu : function(){
        var content = onsweb.menu.get_sub_menu(this.data.current_menu_item);
        if(this.data.pages[this.data.current_menu_item.page_id]){
            content += onsweb.template.view('page_text', 'page', this.data.pages[this.data.current_menu_item.page_id]);
        }
        onsweb.page_writer.fill_content(content);
    },
    _init_current_menu_item : function(menu_item){
        if(menu_item == undefined){
            this.data.current_menu_item = onsweb.menu.get_current_menu_item();
        } else {
            this.data.current_menu_item = menu_item;
        }
    }
};

onsweb.plugins.news = {
    defaults : {
        overview_class : 'o-news-overview',
        item_class : 'o-news-item-block',
        refresh_class : 'o-refresh-overview',
        next_class : 'o-next-news-item',
        prev_class : 'o-prev-news-item'
    },
    data : {
        current_menu_item : null,
        news_items : null,
        is_item : false,
        item_id : null
    },
    show_overview : function(){
        this._init_current_menu_item();
        this._init_live_bar();
        this._init_news_items();
        this._init_url();
        this._create_output();

    },
    refresh_news_overview : function(){
        this.data.news_items = onsweb.ajax.call('get_news_items',{});
        onsweb.data.set('news', this.data.news_items);
        this.show_overview();
        onsweb.menu.bind_links();
    },

    refresh_live_bar : function(){
        this.data.livescore= onsweb.ajax.call('get_livescore',{});
    },

    _init_current_menu_item : function(){
        this.data.current_menu_item = onsweb.menu.data.current_menu_item;
    },
    _init_news_items : function(){
        if(this.data.news_items == null){
            this.data.news_items = onsweb.data.get('news');
            if(this.data.news_items == undefined){
                this.data.news_items = onsweb.ajax.call('get_news_items',{});
            }
        }
    },
    _init_live_bar : function(){
        this.data.livescore= onsweb.ajax.call('get_livescore',{});
    },

    _init_url : function(){
        var parts = onsweb.url.get_hash();
        if(this.data.news_items['i-'+parts[parts.length - 1]]){
            this.data.is_item = true;
            this.data.item_id = parts[parts.length - 1];
        } else {
            this.data.is_item = false;
            this.data.item_id = null;
        }
    },
    _create_output : function(){
        if(this.data.is_item){
            this._create_item_page();
        } else {
            this._create_news_overview_page();
            this._create_refresh_button();
        }
    },
    _create_news_overview_page : function(){
        if(this.data.news_items.length > 0 || 1){
            var content = '',curr_group = null,item = null;

            var result,rel;
            if(this.data.livescore !== null){
                switch (this.data.livescore.result.status) {


                    case 1:
                        if (/^\d*$/.test(this.data.livescore.result.btn)){
                            result = 'NU '+this.data.livescore.result.btn +' LIVE';
                            button_class="live-button";
                        }else{
                            result = this.data.livescore.result.btn;
                            button_class="nextlive-button";
                        }
                        rel = 'match-overview';

                        break;

                    case 2 :
                        result = this.data.livescore.result.btn;
                        rel = 'nomatch';
                        button_class="nextlive-button";
                        break;

                    default :
                        result = this.data.livescore.result.btn;
                        rel = 'nomatch';
                        button_class="nextlive-button";
                        break;
                }

                content += onsweb.template.view('news','live_bar',{
                    items: result,
                    button : button_class,
                    rel: rel
                });

            }



            $.each(this.data.news_items,function(){
                item = this;
                if(item.gi != curr_group){
                    item.gt = item.gt.charAt(0).toUpperCase() + item.gt.slice(1);
                    content += onsweb.template.view('news','overview_list_group',{
                        title: item.gt,
                        class_name: item.gc
                    });
                    curr_group = item.gi;
                }
                item.bind_class = onsweb.menu.defaults.add_class;
                content += onsweb.template.view('news','overview_list_item', item);
            });
            onsweb.page_writer.fill_content(onsweb.template.view('news','overview_list',{
                items: content,
                overview_class: onsweb.plugins.news.defaults.overview_class
            }));
            /* Items shown, now set the images so they can be loaded one by one */
            this._create_news_overview_page_load_images();

              if(this.data.livescore.result.status === 0){
                 $('.live_bar').css({
                            'display':'none'
                        });
            }
        } else {
            onsweb.page_writer.fill_content(gt('Geen nieuws items gevonden. Controleer je internet verbinding en probeer het later nog een keer.'));
        }
    },
    _create_news_overview_page_load_images: function(){
        var item = null,id=null;
        $.each($('.'+onsweb.plugins.news.defaults.overview_class+' ul li.news-item'),function(){
            item = $(this);
            id = 'i-'+item.attr('rel');
            if(onsweb.plugins.news.data.news_items[id] && onsweb.plugins.news.data.news_items[id].p != ''){
                item.find('.picture').css({
                    'background-image': 'url('+onsweb.plugins.news.data.news_items[id].p+')'
                });
            }

        });

    },
    _create_item_page : function (){
        var item_id = 'i-'+this.data.item_id;

        if(this.data.news_items[item_id].tt == undefined){
            var news_item_key = 'news_item_'+this.data.item_id,item = onsweb.data.get(news_item_key);
            if(item == null || item == undefined){
                item = onsweb.ajax.call('get_news_item', {
                    id: this.data.item_id
                });
                onsweb.data.set(news_item_key, item);
            }
            onsweb.console.log(item);
            this.data.news_items[item_id].tt = item.tt;
            this.data.news_items[item_id].it = item.it;
            this.data.news_items[item_id].pt = item.pt;
            this.data.news_items[item_id].pw = item.pw;
            this.data.news_items[item_id].ph = item.ph;
            this.data.news_items[item_id].dt = item.dt;
        }
        this.data.news_items[item_id].item_class = this.defaults.item_class;
        onsweb.page_writer.fill_content(onsweb.template.view('news','item',this.data.news_items[item_id]));
        if (this.data.news_items[item_id].pt != ''){
            $('.'+this.defaults.item_class).find('.picture').css({
                'background-image': 'url('+this.data.news_items[item_id].pt+')',
                'width' : this.data.news_items[item_id].pw+'px',
                'height' : this.data.news_items[item_id].ph+'px'
            });
        }
//        onsweb.menu.set_header_title(this.data.news_items[item_id].t);
        onsweb.menu.set_header_title(gt('Nieuws'));
        onsweb.console.log('creating back and front buttons');
        onsweb.menu.set_header_right_menu(onsweb.template.view('news','top_right_item_menu',{
            ne : this.data.news_items[item_id].ne,
            ne_class: this.defaults.next_class,
            pr : this.data.news_items[item_id].pr,
            pr_class : this.defaults.prev_class
        }))
        this._bind_header_right_menu();
        onsweb.menu.bind_header_back_button('level');
    },
    _create_refresh_button : function(){
        onsweb.menu.set_header_right_menu(onsweb.template.view('news', 'top_right_menu',{
            class_name : this.defaults.refresh_class
        }));
        $('.'+this.defaults.refresh_class).unbind('click').click(function(){
            onsweb.loader.start('onsweb::plugins::news::refresh');
            onsweb.plugins.news.refresh_news_overview();
            onsweb.plugins.news.refresh_live_bar();
        });
    },





    _bind_header_right_menu : function(){
        $('.'+this.defaults.next_class+' , .'+this.defaults.prev_class).unbind('click').click(function(){
            if(!$(this).hasClass('inactive')){
                onsweb.url.change_hash('home/'+$(this).attr('rel'));
            }
        });
        $('.'+this.defaults.next_class).attr('rel') == 0 ? $('.'+this.defaults.next_class).addClass('inactive') : $('.'+this.defaults.next_class).removeClass('inactive');
        $('.'+this.defaults.prev_class).attr('rel') == 0 ? $('.'+this.defaults.prev_class).addClass('inactive') : $('.'+this.defaults.prev_class).removeClass('inactive');
    }
};

onsweb.plugins.calendar = {
    defaults : {
        overview_class : 'o-calendar-overview',
        item_class : 'o-calendar-item-block',
        refresh_class : 'o-refresh-overview',
        next_class : 'o-next-calendar-item',
        prev_class : 'o-prev-calendar-item'
    },
    data : {
        current_menu_item : null,
        calendar_items : null,
        is_item : false,
        item_id : null
    },
    show_overview : function(){
        this._init_current_menu_item();
        this._init_calendar_items();
        this._init_url();
        this._create_output();

    },
    refresh_calendar_overview : function(){
        this.data.calendar_items = onsweb.ajax.call('get_calendar_items',{});
        onsweb.data.set('calendar', this.data.calendar_items);
        this.show_overview();
        onsweb.menu.bind_links();
    },
    _init_current_menu_item : function(){
        this.data.current_menu_item = onsweb.menu.data.current_menu_item;
    },
    _init_calendar_items : function(){
        if(this.data.calendar_items == null){
            this.data.calendar_items = onsweb.data.get('calendar');
            if(this.data.calendar_items == undefined){
                this.data.calendar_items = onsweb.ajax.call('get_calendar_items',{});
            }
        }
    },
    _init_url : function(){
        var parts = onsweb.url.get_hash();
        if(this.data.calendar_items != null && this.data.calendar_items['i-'+parts[parts.length - 1]]){
            this.data.is_item = true;
            this.data.item_id = parts[parts.length - 1];
        } else {
            this.data.is_item = false;
            this.data.item_id = null;
        }
    },
    _create_output : function(){
        if(this.data.is_item){
            this._create_item_page();
        } else {
            this._create_calendar_overview_page();
            this._create_refresh_button();
        }
    },
    _create_calendar_overview_page : function(){
        if(this.data.calendar_items != null){
            var content = '',curr_group = null,item = null;
            $.each(this.data.calendar_items,function(){
                item = this;
                if(item.i > 0 || item.gi >0){
                    if(item.gi != curr_group && item.gi > 0){
                        content += onsweb.template.view('calendar','overview_list_group',{
                            title: item.gt,
                            class_name: item.gc
                        });
                        curr_group = item.gi;
                    }
                    item.bind_class = onsweb.menu.defaults.add_class;
                    content += onsweb.template.view('calendar','overview_list_item', item);
                }
            });
            onsweb.page_writer.fill_content(onsweb.template.view('calendar','overview_list',{
                items: content,
                overview_class: onsweb.plugins.calendar.defaults.overview_class
            }));
        /* Items shown, now set the images so they can be loaded one by one */
        } else {
            onsweb.page_writer.fill_content(gt('Geen nieuws items gevonden. Controleer je internet verbinding en probeer het later nog een keer.'));
        }
		onsweb.menu.bind_header_back_button('go_hash', 'events');
    },
    _create_calendar_overview_page_load_images: function(){
        var item = null,id=null;
        $.each($('.'+onsweb.plugins.calendar.defaults.overview_class+' ul li.calendar-item'),function(){
            item = $(this);
            id = 'i-'+item.attr('rel');
            if(onsweb.plugins.calendar.data.calendar_items[id] && onsweb.plugins.calendar.data.calendar_items[id].p != ''){
                item.find('.picture').css({
                    'background-image': 'url('+onsweb.plugins.calendar.data.calendar_items[id].p+')'
                });
            }

        });
    },
    _create_item_page : function (){
        var item_id = 'i-'+this.data.item_id;

        if(this.data.calendar_items[item_id].tt == undefined){
            var calendar_item_key = 'calendar_item_'+this.data.item_id,item = onsweb.data.get(calendar_item_key);
            if(item == null || item == undefined){
                item = onsweb.ajax.call('get_calendar_item', {
                    id: this.data.item_id
                });
                onsweb.data.set(calendar_item_key, item);
            }
            this.data.calendar_items[item_id].tt = item.tt;
            this.data.calendar_items[item_id].it = item.it;
        }
        this.data.calendar_items[item_id].item_class = this.defaults.item_class;
        onsweb.page_writer.fill_content(onsweb.template.view('calendar','item',this.data.calendar_items[item_id]));
        if (this.data.calendar_items[item_id].p != ''){
            $('.'+this.defaults.item_class).find('.picture').css({
                'background-image': 'url('+this.data.calendar_items[item_id].p+')'
            });
        }
//        onsweb.menu.set_header_title(this.data.calendar_items[item_id].t);
        onsweb.menu.set_header_title(gt('Kalender'));
        onsweb.menu.set_header_right_menu(onsweb.template.view('calendar','top_right_item_menu',{
            ne : this.data.calendar_items[item_id].ne,
            ne_class: this.defaults.next_class,
            pr : this.data.calendar_items[item_id].pr,
            pr_class : this.defaults.prev_class
        }))
        this._bind_header_right_menu();
        onsweb.menu.bind_header_back_button('level');
    },
    _create_refresh_button : function(){
        onsweb.menu.set_header_right_menu(onsweb.template.view('calendar', 'top_right_menu',{
            class_name : this.defaults.refresh_class
        }));
        $('.'+this.defaults.refresh_class).unbind('click').click(function(){
            onsweb.loader.start('onsweb::plugins::calendar::refresh');
            onsweb.plugins.calendar.refresh_calendar_overview();
        });
    },
    _bind_header_right_menu : function(){
        $('.'+this.defaults.next_class+' , .'+this.defaults.prev_class).unbind('click').click(function(){
            if(!$(this).hasClass('inactive')){
                onsweb.url.change_hash('events/calendar/'+$(this).attr('rel'));
            }
        });

        $('.'+this.defaults.next_class).attr('rel') == 0 ? $('.'+this.defaults.next_class).addClass('inactive') : $('.'+this.defaults.next_class).removeClass('inactive');
        $('.'+this.defaults.prev_class).attr('rel') == 0 ? $('.'+this.defaults.prev_class).addClass('inactive') : $('.'+this.defaults.prev_class).removeClass('inactive');
    }
};

onsweb.plugins.tournaments = {
    defaults : {
        overview_class : 'o-calendar-overview',
        item_class : 'o-calendar-item-block',
        refresh_class : 'o-refresh-overview',
        next_class : 'o-next-calendar-item',
        prev_class : 'o-prev-calendar-item'
    },
    data : {
        current_menu_item : null,
        calendar_items : null,
        is_item : false,
        item_id : null
    },
    show_overview : function(){
        this._init_current_menu_item();
        this._init_calendar_items();
        this._init_url();
        this._create_output();

    },
    refresh_calendar_overview : function(){
        this.data.calendar_items = onsweb.ajax.call('get_tournament_items',{});
        onsweb.data.set('tournaments', this.data.calendar_items);
        this.show_overview();
        onsweb.menu.bind_links();
    },
    _init_current_menu_item : function(){
        this.data.current_menu_item = onsweb.menu.data.current_menu_item;
    },
    _init_calendar_items : function(){
        if(this.data.calendar_items == null){
            this.data.calendar_items = onsweb.data.get('tournaments');
            if(this.data.calendar_items == undefined){
                this.data.calendar_items = onsweb.ajax.call('get_tournament_items',{});
            }
        }
    },
    _init_url : function(){
        var parts = onsweb.url.get_hash();
        if(this.data.calendar_items != null && this.data.calendar_items['i-'+parts[parts.length - 1]]){
            this.data.is_item = true;
            this.data.item_id = parts[parts.length - 1];
        } else {
            this.data.is_item = false;
            this.data.item_id = null;
        }
    },
    _create_output : function(){
        if(this.data.is_item){
            this._create_item_page();
        } else {
            this._create_calendar_overview_page();
            this._create_refresh_button();
        }
    },
    _create_calendar_overview_page : function(){
        if(this.data.calendar_items != null){
            var content = '',curr_group = null,item = null;
            $.each(this.data.calendar_items,function(){
                item = this;
                if(item.i > 0 || item.gi >0){
                    if(item.gi != curr_group && item.gi > 0){
                        content += onsweb.template.view('calendar','overview_list_group',{
                            title: item.gt,
                            class_name: item.gc
                        });
                        curr_group = item.gi;
                    }
                    item.bind_class = onsweb.menu.defaults.add_class;
                    content += onsweb.template.view('calendar','overview_list_item', item);
                }
            });
            onsweb.page_writer.fill_content(onsweb.template.view('calendar','overview_list',{
                items: content,
                overview_class: onsweb.plugins.calendar.defaults.overview_class
            }));
        /* Items shown, now set the images so they can be loaded one by one */
        } else {
            onsweb.page_writer.fill_content(gt('Geen nieuws items gevonden. Controleer je internet verbinding en probeer het later nog een keer.'));
        }
		onsweb.menu.bind_header_back_button('go_hash', 'events');
    },
    _create_calendar_overview_page_load_images: function(){
        var item = null,id=null;
        $.each($('.'+onsweb.plugins.calendar.defaults.overview_class+' ul li.calendar-item'),function(){
            item = $(this);
            id = 'i-'+item.attr('rel');
            if(onsweb.plugins.calendar.data.calendar_items[id] && onsweb.plugins.calendar.data.calendar_items[id].p != ''){
                item.find('.picture').css({
                    'background-image': 'url('+onsweb.plugins.calendar.data.calendar_items[id].p+')'
                });
            }

        });
    },
    _create_item_page : function (){
        var item_id = 'i-'+this.data.item_id;

        if(this.data.calendar_items[item_id].tt == undefined){
            var calendar_item_key = 'calendar_item_'+this.data.item_id,item = onsweb.data.get(calendar_item_key);
            if(item == null || item == undefined){
                item = onsweb.ajax.call('get_tournament_item', {
                    id: this.data.item_id
                });
                onsweb.data.set(calendar_item_key, item);
            }
            this.data.calendar_items[item_id].tt = item.tt;
            this.data.calendar_items[item_id].it = item.it || '';
        }
        this.data.calendar_items[item_id].item_class = this.defaults.item_class;
        onsweb.page_writer.fill_content(onsweb.template.view('calendar','item',this.data.calendar_items[item_id]));
        if (this.data.calendar_items[item_id].p != ''){
            $('.'+this.defaults.item_class).find('.picture').css({
                'background-image': 'url('+this.data.calendar_items[item_id].p+')'
            });
        }
//        onsweb.menu.set_header_title(this.data.calendar_items[item_id].t);
        onsweb.menu.set_header_title(gt('Toernooikalender'));
        onsweb.menu.set_header_right_menu(onsweb.template.view('calendar','top_right_item_menu',{
            ne : this.data.calendar_items[item_id].ne,
            ne_class: this.defaults.next_class,
            pr : this.data.calendar_items[item_id].pr,
            pr_class : this.defaults.prev_class
        }))
        this._bind_header_right_menu();
        onsweb.menu.bind_header_back_button('level');
    },
    _create_refresh_button : function(){
        onsweb.menu.set_header_right_menu(onsweb.template.view('calendar', 'top_right_menu',{
            class_name : this.defaults.refresh_class
        }));
        $('.'+this.defaults.refresh_class).unbind('click').click(function(){
            onsweb.loader.start('onsweb::plugins::tournaments::refresh');
            onsweb.plugins.tournaments.refresh_calendar_overview();
        });
    },
    _bind_header_right_menu : function(){
        $('.'+this.defaults.next_class+' , .'+this.defaults.prev_class).unbind('click').click(function(){
            if(!$(this).hasClass('inactive')){
                onsweb.url.change_hash('events/tournament-calender/'+$(this).attr('rel'));
            }
        });
        $('.'+this.defaults.next_class).attr('rel') == 0 ? $('.'+this.defaults.next_class).addClass('inactive') : $('.'+this.defaults.next_class).removeClass('inactive');
        $('.'+this.defaults.prev_class).attr('rel') == 0 ? $('.'+this.defaults.prev_class).addClass('inactive') : $('.'+this.defaults.prev_class).removeClass('inactive');
    }
};

onsweb.plugins.websql = {
    has_db : function(){
        return window.openDatabase ? true : false;
    },
    db : window.openDatabase('user','1.0','login', 1024),
    init : function(){
        if(this.has_db())
        {
            onsweb.console.log('Init database');
            this.db.transaction(function(tx) {
                tx.executeSql("create table if not exists user ("
                    + "key text"
                    + ")",null,null, this.log);
            });
        }
    },
    set : function(d){
        if(this.has_db())
        {
            var data = JSON.stringify(d);
            onsweb.console.log('Set the data:');
            this.del();
            this.db.transaction(function(tx){
                onsweb.console.log('Insert data?');
                tx.executeSql("insert into user (key) values (?)", [data], null, this.log);
            });
        }
    },
    get : function(callback){
        if(this.has_db())
        {
            this.db.transaction(function(tx){
                onsweb.console.log('Start get userdata!!');
                tx.executeSql("select key from user", null, function(tx, results){
                    for (var i=0; i<results.rows.length; i++) {
                        var record = results.rows.item(i),
                        d = jQuery.parseJSON(record.key);

                        onsweb.console.log(d);
                        return d;
                    }
                });
                return {};
            });
        }
    },
    del : function(){
        if(this.has_db())
        {
            this.db.transaction(function(tx){
                onsweb.console.log('Delete user data');
                tx.executeSql("delete from user", null, null, this.log);
            });
        }
    },
    reload : function(){
        if(this.has_db()){
            this.db.transaction(function(tx){
                onsweb.console.log('Init userdata!!');
                tx.executeSql("select key from user", null, function(tx, results){

                    for (var i=0; i<results.rows.length; i++) {
                        var user = onsweb.data.get('user');
                        if(user == undefined || user == '')
                        {
                            var record = results.rows.item(i),
                            d = jQuery.parseJSON(record.key);

                            onsweb.console.log(d);
                            onsweb.data.set('user', d);
                            onsweb.plugins.auth.init();
                            onsweb.url.change_hash(onsweb.url.get_hash().join('/'));

                        }
                    }
                });
            });
        }
    },
    log : function(tx, error) {
        onsweb.console.warn("Error", error.message);
    }
};

onsweb.plugins.auth = {
    defaults : {
        login_form_class : 'o-login-block',
        login_button_class : 'o-login-button',
        password_button_class : 'o-password-button',
        input_username_class : 'o-username-input',
        input_password_class : 'o-password-input',
        logout_top_button : 'o-logout-button'
    },
    data : {
        is_logged_in : false,
        username : null,
        password : null,
        user : {},
        login_with_return : false,
        login_return_data : {
            hash : null,
            callback:null
        }
    },
    init : function(){
        onsweb.plugins.websql.reload();

        if(this.data.user == null || this.data.user.i == undefined){
            this.data.user = onsweb.data.get('user');

            if(this.data.user != undefined && this.data.user.i != undefined){
                this.data.is_logged_in = true;
            } else {
                this.data.is_logged_in = false;
            }
        }
    },
    show_login : function(){
        /* Check if the user is logged in, if he is redirect him to home */
        if(this.is_logged_in()){

        }
        this._create_login_page();
    },
    show_login_with_return : function(hash,callback){
        this.data.login_with_return = true;
        this.data.login_return_data = {
            hash : hash,
            callback : callback
        };
        this._create_login_page();
    },
    is_logged_in : function(){
        return this.data.is_logged_in;
    },
    login : function(username, password){
        this._clear_login_error();
        if ((username == gt('E-mailadres') || username == '') || (password == gt('Wachtwoord') || password == '')){
            onsweb.console.warn('Username/Password not accepted! U:'+username);
            this.data.is_logged_in = false;
            this.user = {};
            //onsweb.plugins.websql.del();
            return false;
        } else {
            this.data.username = username;
            this.data.password = password;

            password = hex_md5(password);
            this.data.user = onsweb.ajax.call('login',{
                username:username,
                password: password
            });
            if(this.data.user != false && this.data.user != null && this.data.user.auth_key != undefined){
                this.data.is_logged_in = true;
                onsweb.console.log('User logged in with the following data:');
                onsweb.console.log(this.data.user);
                this.data.user.forever = true;
                onsweb.data.set('user', this.data.user);
                onsweb.plugins.websql.set(this.data.user);
                return true;
            } else {
                this._set_login_error(gt('E-mailadres en/of Wachtwoord incorrect.'));
                onsweb.console.log('User rejected.');
                this.data.is_logged_in = false;
                this.user = {};
                onsweb.plugins.websql.del();
                return false;
            }
        }
    },
    add_logout_top_button : function(){
        onsweb.menu.set_header_right_menu(onsweb.template.view('auth','logout_top_button', {
            class_name : this.defaults.logout_top_button
        }));
        $('.'+this.defaults.logout_top_button).unbind('click').click(function(){
            onsweb.plugins.auth.do_logout();
        });
    },
    do_logout : function(){
        onsweb.plugins.auth.data.is_logged_in = false;
        onsweb.plugins.auth.data.user = {};
        onsweb.plugins.websql.del();
        onsweb.data.set('user', {});
        onsweb.url.change_hash('home');

    },
    get_user_info : function(id){
        if(id == undefined || !id > 0){
            id = this.data.user.i;
        }
        var r = onsweb.ajax.call('get_user_info',{
            ak: this.data.user.auth_key,
            id: id
        });
        if(r.invalid == undefined || r.invalid == true){
            this.do_logout();
            return null;
        } else {
            return r;
        }

    },
    get_user_favorites : function(id){
        if(id == undefined && this.data.user == null){
            return '';
        } else if(id == undefined || !id > 0){
            id = this.data.user.i;
        }
        var r = onsweb.ajax.call('get_app_favorites',{
            ak: this.data.user.auth_key,
            user_id: id
        });
        if(r.invalid == undefined || r.invalid == true){
            this.do_logout();
            return null;
        } else {
            return r;
        }

    },
    delete_user_favorite : function(d,id){
        if(id == undefined || !id > 0){
            id = this.data.user.i;
        }
        d.ak = this.data.user.auth_key;
        d.user_id = id;
        var r = onsweb.ajax.call('delete_user_favorite',d);
        if(r.invalid == undefined || r.invalid == true){
            this.do_logout();
            return null;
        } else {
            return r;
        }
    },
    add_user_favorite : function(d,id){
        if(id == undefined || !id > 0){
            id = this.data.user.i;
        }
        d.ak = this.data.user.auth_key;
        d.user_id = id;
        var r = onsweb.ajax.call('add_user_favorite',d);
        if(r.invalid == undefined || r.invalid == true){
            this.do_logout();
            return null;
        } else {
            return r;
        }
    },
    save_user_info : function(data,id){
        if(id == undefined || !id > 0){
            id = this.data.user.i;
        }
        data.ak = this.data.user.auth_key;
        data.id = id;
        var r = onsweb.ajax.call('save_user_info',data);
        if(r.invalid == undefined || r.invalid == true){
            this.do_logout();
            return null;
        } else {
            return r;
        }
    },
    _check_login_data : function(){

    },
    _create_login_page : function(){

        var d = {
            login_form_class : this.defaults.login_form_class,
            //username : this.data.username != null ? this.data.username : gt('E-mailadres'),
            username : gt('E-mailadres'),
            //password : this.data.password != null ? this.data.password : gt('Wachtwoord'),
            password :  gt('Wachtwoord'),
            login_button_class : this.defaults.login_button_class,
            password_button_class : this.defaults.password_button_class,
            input_username_class : this.defaults.input_username_class,
            input_password_class : this.defaults.input_password_class
        };
        onsweb.page_writer.fill_content(onsweb.template.view('auth','login_page',d));

        this._bind_buttons();
    },
    _bind_buttons : function(){
        $('.'+this.defaults.login_button_class).unbind('click').click(function(){
            if(onsweb.plugins.auth.login($('.'+onsweb.plugins.auth.defaults.input_username_class).val(),$('.'+onsweb.plugins.auth.defaults.input_password_class).val()) == true && onsweb.plugins.auth.is_logged_in()){
                if(onsweb.plugins.auth.data.login_with_return){
                    onsweb.console.log('Logged in... calling return function');
                    onsweb.plugins.auth._do_login_with_return();
                }else if(onsweb.plugins.auth.data.redirect_hash != undefined){
                    onsweb.console.log('Logged in... redirecting...');
                    onsweb.url.change_hash(onsweb.plugins.auth.data.redirect_hash.join('/'));
                } else {
                    onsweb.url.change_hash('mijn-nhv');
                    onsweb.console.log('Logged in... no redirect found...');
                }
            } else {
                onsweb.console.log('Is logged in not set...');
            }
        });
        $('.'+this.defaults.password_button_class).unbind('click').click(function(){
            //onsweb.plugins.auth.show_password_reset_page();
            onsweb.url.change_hash('password-reset');
        });
        $('.'+onsweb.plugins.auth.defaults.input_password_class).unbind('focus').focus(function(){
            if($(this).val() == gt('Wachtwoord')){
                $(this).val('');
            //this.type = 'password';
            }
        }).unbind('blur').blur(function(){
            if($(this).val() == ''){
            //$(this).val(gt('Wachtwoord'));
            //this.type = 'text';
            }
        });
        $('.'+onsweb.plugins.auth.defaults.input_username_class).unbind('focus').focus(function(){
            if($(this).val() == gt('E-mailadres')){
                $(this).val('');
            }
        }).unbind('blur').blur(function(){
            if($(this).val() == ''){
                $(this).val(gt('E-mailadres'));
            }
        });
    },
    _do_login_with_return : function(){
        if(this.is_logged_in() && onsweb.plugins.auth.data.login_with_return){
            onsweb.plugins.auth.data.login_with_return = false;
            if(this.data.login_return_data.callback != undefined && this.data.login_return_data.callback != null){
                onsweb.console.log('Return callback function calling: ' + this.data.login_return_data.callback);
                this.data.login_return_data.callback();
                this.data.login_return_data.callback = null;
            }
            if(this.data.login_return_data.hash != undefined && this.data.login_return_data.hash != null){
                onsweb.console.log('Redirect to hash called '+ this.data.login_return_data.hash);
                var hash = this.data.login_return_data.hash;
                this.data.login_return_data.hash = null;
                onsweb.url.change_hash(this.data.login_return_data.hash);
            }
        }
    },
    _set_login_error : function(error){
        $('.'+this.defaults.login_form_class).find('.error').html(error);
    },
    _clear_login_error : function(){
        $('.'+this.defaults.login_form_class).find('.error').html('');
    }

};